﻿function ARKINV:RuleUiFrameClose()
	ARKINV_Rules:Hide()
end

function ARKINV:RuleUiFrameTitleSet()

	-- set the title
	obj = getglobal( "ARKINV_RulesTitleWho" )

	t = format( "%s: %s v%.2f", ARKINV_L["MOD_MENU_MAIN_RULES"], ARKINV_G.PROGRAM_NAME, ARKINV_G.PROGRAM_VERSION )

	if ARKINV_G.PROGRAM_BETA then
		t = t .. " " .. RED_FONT_COLOR_CODE .. "(beta " .. ARKINV_G.PROGRAM_BETA .. ")"
	end
	
	obj:SetText( t )
	
end

function ARKINV:UiSetEditBoxLabel( arg1 )
	getglobal( this:GetName() .. "Label" ):SetText( arg1 )
end

function ARKINV:UiTabToNext()
	
	local k = { this:GetParent():GetChildren() }
	local i1 = this:GetID()
	
	--self:Print( "Tab From [" .. this:GetName() .. "] id=[" .. i1 .. "]" )
	
	if not i1 or i1 == 0 then
		self:Print( RED_FONT_COLOR_CODE .. "OOPS: Attempted to tab from a widget with no ID [" .. this:GetName() .. "]" )
		return
	end
	
	if not k then
		self:Print( RED_FONT_COLOR_CODE .. "OOPS: Parent [" .. this:GetParent():GetName() .. "] has no children?" )
	end

	local i2 = 999999
	
	-- scan through all children to find the next highest id
	local x
	for _, w in ipairs( k ) do
		--self:Print( "this=" .. w:GetName() .. ", id=" .. w:GetID() .. ", visible=" .. w:IsVisible() )
		if w:IsVisible() and w:GetID() > i1 and w:GetID() < i2 then
			x = w
			i2 = x:GetID()
		end
	end

	-- if found then focus and exit
	if x then
		--self:Print( "Tab To [" .. x:GetName() .. "] id=[" .. i2 .. "]" )
		x:SetFocus()
		return
	end

	-- if not found then we're at the end or there's only a single entry so look for the lowest id
	for _, w in ipairs( k ) do
		if w:IsVisible() and w:GetID() > 0 then
			--self:Print( "Tab To [" .. w:GetName() .. "] id=[" .. w:GetID() .. "]" )
			w:SetFocus()
			return
		end
	end
	
	-- should never get here
	self:Print( RED_FONT_COLOR_CODE .. "OOPS: We shouldn't be here @ ARKINV:UiTabToNext()" )
	
end


function ARKINV:RuleUiStructureSort()

	local f = this:GetName()
	
	local x
	
	--enabled
	x = getglobal( f .. "_T1" )
	x:ClearAllPoints()
	x:SetWidth( 32 )
	x:SetPoint( "TOP", 0, 0 )
	x:SetPoint( "BOTTOM", 0, 0 )
	x:SetPoint( "LEFT", 15, 0 )
	x:SetText( "Use" )
	x:Show()

	--damaged
	x = getglobal( f .. "_T2" )
	x:ClearAllPoints()
	x:SetWidth( 32 )
	x:SetPoint( "TOP", 0, 0 )
	x:SetPoint( "BOTTOM", 0, 0 )
	x:SetPoint( "LEFT", f .. "_T1", "RIGHT", 5, 0 )
	x:SetText( "Dmg" )
	x:Show()
	
	-- id
	x = getglobal( f .. "_C1" )
	x:ClearAllPoints()
	x:SetWidth( 50 )
	x:SetPoint( "LEFT", f .. "_T2", "RIGHT", 5, 0 )
	x:SetPoint( "TOP", 0, 0 )
	x:SetPoint( "BOTTOM", 0, 0 )
	x:SetText( "Rule" )
	x:Show()

	-- order
	x = getglobal( f .. "_C2" )
	x:ClearAllPoints()
	x:SetWidth( 50 )
	x:SetPoint( "LEFT", f .. "_C1", "RIGHT", 5, 0 )
	x:SetPoint( "TOP", 0, 0 )
	x:SetPoint( "BOTTOM", 0, 0 )
	x:SetText( "Order" )
	x:Show()

	-- description
	x = getglobal( f .. "_C3" )
	x:ClearAllPoints()
	x:SetPoint( "LEFT", f .. "_C2", "RIGHT", 5, 0 )
	x:SetPoint( "TOP", 0, 0 )
	x:SetPoint( "BOTTOM", 0, 0 )
	x:SetPoint( "RIGHT", -35, 0 )
	x:SetText( "Description" )
	x:Show()
	
end

function ARKINV:RuleUiStructureRowItem()

	local f = this:GetName()
	
	local x
	
	--enabled
	x = getglobal( f .. "T1" )
	x:ClearAllPoints()
	x:SetWidth( 22 )
	x:SetHeight( 22 )
	x:SetPoint( "LEFT", 15, 0 )
	x:Show()

	--damaged
	x = getglobal( f .. "T2" )
	x:ClearAllPoints()
	x:SetWidth( 22 )
	x:SetHeight( 22 )
	x:SetPoint( "LEFT", f .. "T1", "RIGHT", 15, 0 )
	x:Show()
	
	-- id
	x = getglobal( f .. "C1" )
	x:ClearAllPoints()
	x:SetWidth( 50 )
	x:SetPoint( "LEFT", f .. "T2", "RIGHT", 10, 0 )
	x:SetPoint( "TOP", 0, 0 )
	x:SetPoint( "BOTTOM", 0, 0 )
	x:SetTextColor( 1, 1, 1, 1 )
	x:SetJustifyH( "CENTER", 0, 0 )
	x:Show()

	-- order
	x = getglobal( f .. "C2" )
	x:ClearAllPoints()
	x:SetWidth( 50 )
	x:SetPoint( "LEFT", f .. "C1", "RIGHT", 5, 0 )
	x:SetPoint( "TOP", 0, 0 )
	x:SetPoint( "BOTTOM", 0, 0 )
	x:SetTextColor( 1, 1, 1, 1 )
	x:SetJustifyH( "CENTER", 0, 0 )
	x:Show()

	-- description
	x = getglobal( f .. "C3" )
	x:ClearAllPoints()
	x:SetPoint( "LEFT", f .. "C2", "RIGHT", 5, 0 )
	x:SetPoint( "TOP", 0, 0 )
	x:SetPoint( "BOTTOM", 0, 0 )
	x:SetPoint( "RIGHT", -5, 0 )
	x:SetJustifyH( "LEFT", 0, 0 )
	x:Show()

end

function ARKINV:RuleUiStructureTable( f )

	if not f or type( f ) ~= "string" then f = this:GetName() end

	local p = getglobal( f )
	if not p then
		self:Print( RED_FONT_COLOR_CODE .. "OOPS: Invalid value at ARKINV:RuleUiStructureTable( [" .. self:MakeNullStringEmpty( f ) .. "] )" )
		return
	end
	
	local maxrows = tonumber( getglobal( f .. "MaxRows" ):GetText() )
	local rows = maxrows
	local height = 30
	
	if rows > maxrows then rows = maxrows end
	getglobal( f .. "NumRows" ):SetText( rows )
	
	if height == 0 then
		height = tonumber( getglobal( f .. "RowHeight" ):GetText() )
	end
	getglobal( f .. "RowHeight" ):SetText( height )

	-- stretch scrollbar to bottom row
	getglobal( f .. "Scroll" ):SetPoint( "BOTTOM", f .. "Row" .. rows, "BOTTOM", 0, 0 )

	-- set frame height to correct size
	getglobal( f ):SetHeight( height * rows + 20 )

end

function ARKINV:RuleUiTableRowClick()

	local f = this:GetName()
	
	-- self:Print( "RuleTableClick( " .. f .. " )" )
	local parent = getglobal( f ):GetParent():GetName()
	
	local cs = getglobal( parent .. "SelectedRow" ):GetText()
	local ns = tostring( getglobal( f ):GetID() )

	if ns == "0" then
		self:Print( "OOPS: widget [" .. f .. "] has no ID allocated" )
		return false
	end
	
	
	if IsShiftKeyDown() then
	
		-- shift click - enable/disable the rule
		id = tonumber( getglobal( f .. "Id" ):GetText() )
		if id > 0 then
		
			if self.db.profile.option.rule[id].enabled then
			
				self.db.profile.option.rule[id].enabled = false
				self:ClearItemCache()
				self:ContainerGenerateRedrawAll()
			
			else
		
				d = self.db.account.option.rule[id]
				d["enabled"] = true
				self:RuleEntryEdit( id, d )
				
			end
			
		end
	
		self:RuleUiTableRefresh()
		
	else
	
		-- normal click - show/hide selected background
	
		if cs ~= "-1" then
			getglobal( parent .. "Row" .. cs .. "Selected" ):Hide()
		end

		-- second click removes selection		
		if cs == ns then
			getglobal( parent .. "SelectedRow" ):SetText( "-1" )
			getglobal( parent .. "SelectedId" ):SetText( "-1" )
			return
		end
	
		getglobal( parent .. "SelectedRow" ):SetText( ns )
		getglobal( parent .. "SelectedId" ):SetText( getglobal( f .. "Id" ):GetText() )
	
		getglobal( f .. "Selected" ):Show()
		
	end

end

function ARKINV:RuleUiTableReset( f )

	if not f or type( f ) ~= "string" then f = this:GetName() end
	-- hide and reset all rows
	
	local t = f .. "Table"
	
	local h = tonumber( getglobal( t .. "RowHeight" ):GetText() )
	local r = tonumber( getglobal( t .. "NumRows" ):GetText() )

	getglobal( t .. "SelectedRow" ):SetText( "-1" )
	for x = 1, r do
		getglobal( t .. "Row" .. x .. "Selected" ):Hide()
		getglobal( t .. "Row" .. x .. "Id" ):SetText( "-1" )
		getglobal( t .. "Row" .. x ):Hide()
		getglobal( t .. "Row" .. x ):SetHeight( h )
	end

end

function ARKINV:RuleUiTableRefresh( f )

	if not f then
		f = this:GetParent():GetParent():GetParent():GetName()
	end

	-- self:Print( "RuleUiTableRefresh( " .. self:NilString( f ) .. " ), " .. this:GetName() )

	local p = getglobal( f )
	if not p then
		self:Print( RED_FONT_COLOR_CODE .. "OOPS: Invalid widget name at RuleUiTableRefresh( " ..  f .. " )" )
		return
	end
	
	f = f .. "View"
	
	local ft = f .. "Table"
	local fs = f .. "Search"

	local height = tonumber( getglobal( ft .. "RowHeight" ):GetText() )
	local rows = tonumber( getglobal( ft .. "NumRows" ):GetText() )

	local line
	local lineplusoffset
	
	self:RuleUiTableReset( f )

	-- collect all valid items
	local filter = getglobal( fs .. "Filter"):GetText()
	--self:Print( "filter = [" .. filter .. "]" )

	local t = { }
	local tc = 0
	
	local ignore
	
	for k, d in pairs( self.db.account.option.rule ) do

		-- self:Print( "k = [" .. k .. "], order = [" .. d.order .. "], name = [" .. self:MakeNullStringEmpty( d.name ) .. "], formula = [" .. self:MakeNullStringEmpty( d.formula ) .. "]" )
	
		ignore = false
			
		if filter ~= "" then
			if not string.find( string.lower( d.name ), string.lower( filter ) ) then
				ignore = true
			end
		end
		
		if not ignore then
			table.insert( t, { ["sorted"]=format( "%04i %04i", d.order, k ), ["id"]=k, ["enabled"]=self.db.profile.option.rule[k].enabled, ["order"]=d.order, ["name"]=d.name, ["formula"]=d.formula, ["damaged"]=d.damaged } )
			tc = tc + 1
		end

	end

	if tc == 0 then
		return
	end
	
	-- sort them by name
	table.sort( t, function( a, b ) return a.sorted < b.sorted end )

	FauxScrollFrame_Update( getglobal( ft .. "Scroll" ), tc, rows, height )
	
	local linename, c, r
	
	for line = 1, rows do

		linename = ft .. "Row" .. line
		
		lineplusoffset = line + FauxScrollFrame_GetOffset( getglobal( ft .. "Scroll" ) )

		if lineplusoffset <= tc then

			c = ""
			r = t[lineplusoffset]
			
			getglobal( linename .. "Id" ):SetText( r.id )

			if r.enabled then
				getglobal( linename .. "T1" ):SetTexture( "Interface\\Icons\\Spell_ChargePositive" )
			else
				getglobal( linename .. "T1" ):SetTexture( "Interface\\Icons\\Spell_ChargeNegative" )
			end
			
			if r.damaged then
				getglobal( linename .. "T2" ):SetTexture( "Interface\\Icons\\Spell_Shadow_DeathCoil" )
			else
				getglobal( linename .. "T2" ):SetTexture( 0, 0, 0, 0 )
			end

			getglobal( linename .. "C1" ):SetText( r.id )

			c = string.format( r.order )
			getglobal( linename .. "C2" ):SetText( c )

			c = r.name
			if not c then c = "<not set>" end
			getglobal( linename .. "C3" ):SetText( c )

			getglobal( linename ):Show()
			
			-- show selected if id is scrolled into view
			if getglobal( ft .. "SelectedId" ):GetText() == r.order then
				getglobal( ft .. "SelectedRow" ):SetText( line )
				getglobal( ft .. "Row" .. line .. "Selected" ):Show()
			end
			
		else
		
			getglobal( linename .. "Id"):SetText( "-1" )
			getglobal( linename ):Hide()
			
		end
	end

end

function ARKINV_RuleUiTableRefresh( f )
	ARKINV:RuleUiTableRefresh( f )
end


function ARKINV:RuleEntryFormat( d )

	if not d then return end
	
	zOrder = "0"
	zName = ""
	zFormula = ""

	local x1 = d["order"]
	if x1 then zOrder = x1 end

	local x1 = d["name"]
	if x1 then zName = x1 end

	local x1 = d["formula"]
	if x1 then zFormula = x1 end

	d["damaged"] = false
	d["order"] = tonumber( zOrder )
	d["name"] = strtrim( tostring( zName ) )
	d["formula"] = string.gsub( strtrim( tostring( zFormula ) ), "[%a]-%(", string.lower )
	d.formula = string.gsub( d.formula, "%s+", " " )

	
	if d["enabled"] and ( d.enabled == 1 or d.enabled == true ) then
		d["enabled"] = true
	else
		d["enabled"] = false
	end

	return d
	
end

function ARKINV:RuleEntryUpdate( k, d )

	k = tonumber( k )
	self:RuleEntryFormat( d )

	-- increment the rule counter if this is a new rule
	if not self:RuleEntryExists( k ) then
		self.db.account.option.nextrule = self.db.account.option.nextrule + 1
	end

	-- enable/disable the rule at the profile level
	self.db.profile.option.rule[k].enabled = d.enabled
	d.enabled = nil
	
	-- save the rule data at the account level
	self.db.account.option.rule[k] = nil
	for x, v in pairs( d ) do
		if v == nil or v == "" then
			-- do nothing
		else
			self.db.account.option.rule[k][x] = v
		end
	end
	
	self:ClearItemCache()
	self:ContainerGenerateRedrawAll()
	
end

function ARKINV:RuleEntryValidate( k, d )

	if not k then
		return false, "FAILED: passed key is nil"
	end
	
	if not d then
		return false, "FAILED: passed data is nil"
	end

	self:RuleEntryFormat( d )
	
	if d.name == "" then
		return false, "FAILED: description is missing"
	end
	
	if d.formula == "" then
		return false, "FAILED: formula is missing"
	end
	
	ok, em = self:RuleValid( d )
	if not ok then
		d["damaged"] = true
		return false, em
	end

	return true

end

function ARKINV:RuleEntryExists( k )

	if not k then
		error( "passed argument is nil" )
	end
	
	if self.db.account.option.rule[tonumber( k )].order == -1 then
		return false
	else
		return true
	end

end


function ARKINV:RuleEntryAdd( k, d )
	
	local ok, msg = self:RuleEntryValidate( k, d )
	if not ok then
		message( msg )
		return false
	end
	
	self:RuleEntryUpdate( k, d )

	return true

end

function ARKINV:RuleEntryEdit( k, d )

	local ok, msg = self:RuleEntryValidate( k, d )
	if not ok then
		message( msg )
		return false
	end
	
	self:RuleEntryUpdate( k, d )
	
	return true
	
end

function ARKINV:RuleEntryRemove( k )

	if not k then
		error( "FAILED: key is nil" )
	end
	
	if not self:RuleEntryExists( k ) then
		error( "FAILED: key does not exist" )
	end
	
	self.db.account.option.rule[tonumber( k )] = nil
	self.db.profile.option.rule[tonumber( k )] = false

	self:ClearItemCache()
	self:ContainerGenerateRedrawAll()
	
	return true
	
end


function ARKINV:RuleUiModify( t )

	local f = this:GetParent():GetParent():GetParent():GetName()
	
	local fvt = f .. "ViewTable"

	local fm = f .. "Modify"
	local fmt = fm .. "Title"
	local fmd = fm .. "Data"

	getglobal( fm .. "Type" ):SetText( t )

	local k = getglobal( fvt .. "SelectedId" ):GetText()
	if not k then k = "-1" end
	if t == "A" then k = "-1" end

	local v
	
	if k ~= "-1" then
		local d = self.db.account.option.rule[tonumber( k )]
		d["enabled"] = self.db.profile.option.rule[tonumber( k )].enabled
		getglobal( fmd .. "Id" ):SetText( k )
		getglobal( fmd .. "Enabled" ):SetChecked( d.enabled )
		getglobal( fmd .. "Order" ):SetText( self:MakeNullStringEmpty( d.order ) )
		getglobal( fmd .. "Description" ):SetText( self:MakeNullStringEmpty( d.name ) )
		getglobal( fmd .. "ScrollFormula" ):SetText( self:MakeNullStringEmpty( d.formula ) )
	else
		getglobal( fmd .. "Id" ):SetText( self.db.account.option.nextrule )
		getglobal( fmd .. "Enabled" ):SetChecked( true )
		getglobal( fmd .. "Order" ):SetText( "0" )
		getglobal( fmd .. "Description" ):SetText( "" )
		getglobal( fmd .. "ScrollFormula" ):SetText( "false" )
	end

	getglobal( fmd .. "IdLabel" ):SetText( ARKINV_L["MOD_FRAME_RULE_RULE"] .. ":"  )
	getglobal( fmd .. "EnabledLabel" ):SetText( ARKINV_L["MOD_FRAME_RULE_ENABLED"] .. ":"  )
	getglobal( fmd .. "OrderLabel" ):SetText( ARKINV_L["MOD_FRAME_RULE_ORDER"] .. ":"  )
	getglobal( fmd .. "DescriptionLabel" ):SetText( ARKINV_L["MOD_FRAME_RULE_DESCRIPTION"] .. ":"  )
	getglobal( fmd .. "FormulaLabel" ):SetText( ARKINV_L["MOD_FRAME_RULE_FORMULA"] .. ":" )
	
	getglobal( fmd .. "Enabled" ):Show()
	getglobal( fmd .. "Order" ):Show()
	getglobal( fmd .. "Description" ):Show()
	getglobal( fmd .. "ScrollFormula" ):Show()

	getglobal( fmd .. "EnabledReadOnly" ):SetChecked( getglobal( fmd .. "Enabled" ):GetChecked() )
	getglobal( fmd .. "EnabledReadOnly" ):Hide()
	getglobal( fmd .. "OrderReadOnly" ):SetText( getglobal( fmd .. "Order" ):GetText() )
	getglobal( fmd .. "OrderReadOnly" ):Hide()
	getglobal( fmd .. "DescriptionReadOnly" ):SetText( getglobal( fmd .. "Description" ):GetText() )
	getglobal( fmd .. "DescriptionReadOnly" ):Hide()
	getglobal( fmd .. "FormulaReadOnly" ):SetText( getglobal( fmd .. "ScrollFormula" ):GetText() )
	getglobal( fmd .. "FormulaReadOnly" ):Hide()

	if t == "R" then

		if k == "-1" then return end

		getglobal( fmt .. "Text" ):SetText( string.upper( ARKINV_L["MOD_FRAME_RULE_REMOVE"] ) )

		getglobal( fmd .. "Enabled" ):Hide()
		getglobal( fmd .. "EnabledReadOnly" ):Disable()
		getglobal( fmd .. "EnabledReadOnly" ):Show()

		getglobal( fmd .. "Order" ):Hide()
		getglobal( fmd .. "OrderReadOnly" ):Show()

		getglobal( fmd .. "Description" ):Hide()
		getglobal( fmd .. "DescriptionReadOnly" ):Show()

		getglobal( fmd .. "ScrollFormula" ):Hide()
		getglobal( fmd .. "FormulaReadOnly" ):Show()

	elseif t == "E" then

		if k == "-1" then return end

		getglobal( fmt .. "Text" ):SetText( string.upper( ARKINV_L["MOD_FRAME_RULE_EDIT"] ) )

	elseif t == "A" then

		getglobal( fmt .. "Text" ):SetText( string.upper( ARKINV_L["MOD_FRAME_RULE_ADD"] ) )

	else
		self:Print( RED_FONT_COLOR_CODE .. "OOPS: Uncoded argument ARKINV:RuleUiModify( " .. self:MakeNullStringEmpty( t ) .. " )" )
		return
	end

	getglobal( f .. "View" ):Hide()
	getglobal( fm ):Show()

end

function ARKINV:RuleUiModifyOk()

	local f = this:GetParent():GetParent():GetParent():GetParent():GetName()
	local fm = this:GetParent():GetParent():GetName()
	local fmd = fm .. "Data"
	
	local d = { }
	d["enabled"] = getglobal( fmd .. "Enabled" ):GetChecked()
	d["order"] = getglobal( fmd .. "Order" ):GetText()
	d["name"] = getglobal( fmd .. "Description" ):GetText()
	d["formula"] = getglobal( fmd .. "ScrollFormula" ):GetText()

	local k = getglobal( fmd .. "Id" ):GetText()

	f = this:GetParent():GetParent():GetParent():GetName()
	fm = this:GetParent():GetParent():GetName()
	
	local t = getglobal( fm .. "Type" ):GetText()

	if t =="A" then
		if not self:RuleEntryAdd( k, d ) then return end
		getglobal( f .. "ViewTableSelectedId" ):SetText( k )
	elseif t == "E" then
		if not self:RuleEntryEdit( k, d, false ) then return end
	elseif t == "R" then
		if not self:RuleEntryRemove( k ) then return end
		getglobal( f .. "ViewTableSelectedId" ):SetText( "-1" )
	else
		self:Print( RED_FONT_COLOR_CODE .. "OOPS: Uncoded value [" .. t .. "] at ARKINV:RuleUiModifyOk" )
		return
	end

	getglobal( fm ):Hide()
	getglobal( f .. "View" ):Show()

end

function ARKINV:RuleUiModifyCancel()

	f = this:GetParent():GetParent():GetParent():GetName()
	
	getglobal( f .. "Modify" ):Hide()
	getglobal( f .. "View" ):Show()

end


function ARKINV:RuleUiAdd()
	return self:RuleUiModify( "A" )
end

function ARKINV:RuleUiEdit()
	return self:RuleUiModify( "E" )
end

function ARKINV:RuleUiRemove()
	return self:RuleUiModify( "R" )
end






function ARKINV:RuleEntryCompile( d )

	d["compiled"] = ""
	
	if not d["formula"] then return "" end
	
	d.compiled = "return ( " .. d.formula .. " );"
	d.compiled = string.gsub( d.compiled, "[\r\n]", " " )
	d.compiled = string.gsub( d.compiled, "%s+", " " )
	d.compiled = string.gsub( d.compiled, "(%w)%((.-)%)", '%1(nil,"%2")' )

end

function ARKINV:RuleValid( d )

	if not d.formula or strtrim( d.formula ) == "" then
		return false, "Formula is empty"
	end
	
	self:RuleEntryCompile( d )
	
	ARKINV_G.ITEM = { ["count"]=1, ["q"]=1, ["sb"]=true, ["h"]="item:6948:0:0:0:0:0:0:0" } -- hearthstone
	
	local p, eor = loadstring( d.compiled, "Error in formula" )
	
	if ( not p ) then
		return false, eor
	end
	
	local pe = { soulbound=ARKINV.RuleExecuteSoulbound, empty=ARKINV.RuleExecuteEmpty, id=ARKINV.RuleExecuteItemId, type=ARKINV.RuleExecuteItemType, subtype=ARKINV.RuleExecuteItemSubType, equip=ARKINV.RuleExecuteItemEquipLoc, name=ARKINV.RuleExecuteItemName, quality=ARKINV.RuleExecuteItemQuality, pt=ARKINV.RuleExecutePeriodicTable, tooltip=ARKINV.RuleExecuteTooltip, outfit=ARKINV.RuleExecuteOutfit }
	setfenv( p, pe )
	ok, eor = pcall( p )
	
	if not ok then
		return false, eor
	else
		return true
	end
	
end

function ARKINV:RuleAppliesToItem( rulenum, i )

	if not i or self.db.account.option.rule[rulenum].order == -1 or self.db.account.option.rule[rulenum].damaged or not self.db.profile.option.rule[rulenum].enabled then
		return false, nil
	end
	
	if self.db.account.option.rule[rulenum].compiled == ""  then
		return false, "not compiled"
	end
	
	local p, eor = loadstring( self.db.account.option.rule[rulenum].compiled, "Error in rule " .. rulenum .. " [" .. self.db.account.option.rule[rulenum].name .. "]" )
	
	if ( not p ) then
		return nil, eor
	end
	
	ARKINV_G.ITEM = i
	
	local pe = { soulbound=ARKINV.RuleExecuteSoulbound, empty=ARKINV.RuleExecuteEmpty, id=ARKINV.RuleExecuteItemId, type=ARKINV.RuleExecuteItemType, subtype=ARKINV.RuleExecuteItemSubType, equip=ARKINV.RuleExecuteItemEquipLoc, name=ARKINV.RuleExecuteItemName, quality=ARKINV.RuleExecuteItemQuality, pt=ARKINV.RuleExecutePeriodicTable, tooltip=ARKINV.RuleExecuteTooltip, outfit=ARKINV.RuleExecuteOutfit }
	setfenv( p, pe )
	ok, eor = pcall( p )
	
	if not ok then
		return nil, eor
	else
		return eor, nil
	end
	
end




function ARKINV:RuleExecuteSoulbound()

	if ARKINV_G.ITEM.sb then
		return true
	else
		return false
	end
	
end

function ARKINV:RuleExecuteEmpty()

	if not ARKINV_G.ITEM.h or ARKINV_G.ITEM.h == "" then
		return true
	else
		return false
	end
	
end

function ARKINV:RuleExecuteItemId( t )

	if not ARKINV_G.ITEM.h or not t or strtrim( t ) == "" then return false end
	
	for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do
		
		w = strtrim( w ) .. ":"
		e = string.sub( ARKINV:GetItemID( ARKINV_G.ITEM.h ) .. ":", 1, string.len( w ) )
	
		if w == e then
			return true
		end
		
	end
	
	return false
	
end

function ARKINV:RuleExecuteItemType( t )

	if not ARKINV_G.ITEM.h or not t or strtrim( t ) == "" then return false end
	
	e = string.lower( select( 6, GetItemInfo( ARKINV_G.ITEM.h ) ) or "" )
	
	if e ~= "" then
	
		for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do
		
			if e == string.lower( strtrim( w ) ) then
				return true
			end
			
		end
		
	end
	
	return false
	
end

function ARKINV:RuleExecuteItemSubType( t )

	if not ARKINV_G.ITEM.h or not t or strtrim( t ) == "" then return false end
	
	e = string.lower( select( 7, GetItemInfo( ARKINV_G.ITEM.h ) ) or "" )
	
	if e ~= "" then
	
		for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do
		
			if e == string.lower( strtrim( w ) ) then
				return true
			end
			
		end
		
	end
	
	return false
	
end

function ARKINV:RuleExecuteItemEquipLoc( t )

	if not ARKINV_G.ITEM.h then return false end
	
	e = string.sub( string.lower( select( 9, GetItemInfo( ARKINV_G.ITEM.h ) ) or "" ), 9 )
	
	t = string.lower( strtrim( t ) )
	
	if e ~= "" then
	
		if t == "" then
		
			-- no tokens so just check if item can be equipped
			if e == "" then
				return false
			else
				return true
			end
		
		else
		
			for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do
			
				if e == strtrim( w ) then
					return true
				end
				
			end
			
		end
		
	end
	
	return false
	
end

function ARKINV:RuleExecuteItemName( t )

	if not ARKINV_G.ITEM.h or not t or strtrim( t ) == "" then return false end
	
	e = string.lower( ARKINV:GetItemName( ARKINV_G.ITEM.h ) or "" )
	t = string.lower( strtrim( t ) )
	
	for w in string.gmatch( t, ARKINV_L["RULE_PATTERN_SEP"] ) do

		if string.find( e, strtrim( w ) ) then
			return true
		end
			
	end
	
	return false
	
end

function ARKINV:RuleExecuteItemQuality( t )

	if not ARKINV_G.ITEM.h or not t or strtrim( t ) == "" then return false end
	
	t = string.lower( strtrim( t ) )
	for z = 6, 0, -1 do
		t = t:gsub( ARKINV_L["RULE_PATTERN_ITEMQUALITY_" .. z], tostring( z ) )
	end

	for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do
	
		w = strtrim( w )
		
		if w == tostring( ARKINV_G.ITEM.q ) then
			return true
		end

	end
	
	return false
	
end

function ARKINV:RuleExecutePeriodicTable( t )

	if not ARKINV_G.ITEM.h or not t or strtrim( t ) == "" then return false end
	
	return ARKINV:PT_ItemInSets( ARKINV_G.ITEM.h, t )
	
end

function ARKINV:RuleExecuteTooltip( t )

	if not ARKINV_G.ITEM.h or not t or strtrim( t ) == "" then return false end
	
	t = string.lower( strtrim( t ) )
	
	ARKINV:TooltipSetHyperlink( ARKINV_G.ITEM.h )
	
	for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do

		if ARKINV:TooltipContains( strtrim( w ) ) then
			return true
		end
	
	end
	
	return false

end

function ARKINV:RuleExecuteOutfit( t )

	if not ARKINV_G.ITEM.h then return false end
	
	if IsAddOnLoaded( "Outfitter" ) then
		return ARKINV:RuleExecuteOutfitOutfitter( t, ARKINV_G.ITEM.h )
	elseif IsAddOnLoaded( "ItemRack" ) then
		return ARKINV:RuleExecuteOutfitItemRack( t, ARKINV_G.ITEM.h )
	elseif IsAddOnLoaded( "ClosetGnome" ) then
		return ARKINV:RuleExecuteOutfitClosetGnome( t, ARKINV_G.ITEM.h )
	end
	
	return false

end

function ARKINV:RuleExecuteOutfitOutfitter( t, h )

	if not h or not IsAddOnLoaded( "Outfitter" ) then return false end
	
	ItemInfo = Outfitter_GetItemInfoFromLink( h )
	
	if not ItemInfo then return false end
	
	Outfits = Outfitter_GetOutfitsUsingItem( ItemInfo )
	
	if not Outfits or next( Outfits ) == nil then return false end
	
	if not t or strtrim( t ) == "" then
		-- nil t means is it in any outfit
		return true
	end
	
	for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do

		for _, o in pairs( Outfits ) do
			if string.lower( strtrim( o.Name ) ) == string.lower( strtrim( w ) ) then
				return true
			end
		end
		
	end
	
	return false

end

function ARKINV:RuleExecuteOutfitClosetGnome( t, h )

	if not h or not IsAddOnLoaded( "ClosetGnome" ) then return false end
	
	
--	if ClosetGnome.GetOutfitsUsingItem then
	
--		Outfits = ClosetGnome:GetOutfitsUsingItem( h )
	
--	else
	
		Outfits = { }
	
		for n in pairs( ClosetGnome.db.char.set ) do
			for s, v in pairs( ClosetGnome.db.char.set[n] ) do
				if v == h then
					tinsert( Outfits, string.lower( strtrim( n ) ) )
					break
				end
			end
		end
		
--	end

	
	if not Outfits or next( Outfits ) == nil then return false end
	
	if not t or strtrim( t ) == "" then
		-- nil t means is it in any outfit
		return true
	end

	for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do

		for _, o in pairs( Outfits ) do
			if o == string.lower( strtrim( w ) ) then
				return true
			end
		end
	
	end
	
	return false
	
end

function ARKINV:RuleExecuteOutfitItemRack( t, h )

	if not h or not IsAddOnLoaded( "ItemRack" ) then return false end
	
	id = strmatch( h, "item:(.+):")
	
	Outfits = { }
	
	for n in pairs( ItemRackUser.Sets ) do
		for _, v in pairs( ItemRackUser.Sets[n].equip ) do
			if id == v and string.sub( n, 1, 1 ) ~= "~" then
				tinsert( Outfits, string.lower( strtrim( n ) ) )
				break
			end
		end
	end
	
	if not Outfits or next( Outfits ) == nil then return false end
	
	if not t or strtrim( t ) == "" then
		-- nil t means is it in any outfit
		return true
	end

	for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do

		for _, o in pairs( Outfits ) do
			if o == string.lower( strtrim( w ) ) then
				return true
			end
		end
	
	end
	
	return false

end




--[[

function ARKINV:RuleExecuteBagNumber( t )

	if not t or not n then return "false" end

	t = string.lower( strtrim( t ) )
	
	self:Print( "token=[" .. t .. "], bag=[" .. n .. "]" )

	if t == "bag" or t == ARKINV_L["RULE_PATTERN_BAGNUM_BAG"] then
		t = table.concat( ARKINV_G.LOCATION[ARKINV_G.LOCATION_BAG].IDS, "," )
	elseif t == "bank" or t == ARKINV_L["RULE_PATTERN_BAGNUM_BANK"] then
		t = table.concat( ARKINV_G.LOCATION[ARKINV_G.LOCATION_BANK].IDS, "," )
	elseif t == "key" or t == ARKINV_L["RULE_PATTERN_BAGNUM_KEY"] then
		t = table.concat( ARKINV_G.LOCATION[ARKINV_G.LOCATION_KEY].IDS, "," )
	end
		
	for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do
		if n == tonumber( w ) then
			return "true"
		end
	end
	
	return "false"
	
end

function ARKINV:RuleExecuteSlotNumber( t )

	if not t or not n then return "false" end

	for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do
		if n == tonumber( w ) then
			return "true"
		end
	end
	
	return "false"
	
end

function ARKINV:RuleExecuteBagType( t )

	if not t or not b then return "false" end

	bt = self:BagType( b )
	
	for w in t:gmatch( ARKINV_L["RULE_PATTERN_SEP"] ) do

		for k, v in pairs( ARKINV_SLOT_TABLE ) do
			if v["type"] and string.lower( v.type ) == string.lower( strtrim( w ) ) then
				if bt == k then
					return "true"
				end
			end
		end
		
	end
	
	return "false"
	
end

]]--